## mingw-w64-helics-3.6.1-3.src.tar.zst

=== CMakeLists.txt ===
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Copyright (c) 2017-2025, Battelle Memorial Institute; Lawrence Livermore
# National Security, LLC; Alliance for Sustainable Energy, LLC.
# See the top-level NOTICE for additional details.
# All rights reserved.
#
# SPDX-License-Identifier: BSD-3-Clause
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

if(BUILD_PYTHON_INTERFACE
   OR BUILD_PYTHON2_INTERFACE
   OR HELICS_BUILD_PYTHON_INTERFACE
   OR HELICS_BUILD_PYTHON2_INTERFACE
)
    set(tmp_py_interface_option "")
    if(BUILD_PYTHON_INTERFACE)
        set(tmp_py_interface_option "BUILD_PYTHON_INTERFACE")
    elseif(HELICS_BUILD_PYTHON_INTERFACE)
        set(tmp_py_interface_option "HELICS_BUILD_PYTHON_INTERFACE")
    elseif(BUILD_PYTHON2_INTERFACE)
        set(tmp_py_interface_option "BUILD_PYTHON2_INTERFACE")
    elseif(HELICS_BUILD_PYTHON2_INTERFACE)
        set(tmp_py_interface_option "HELICS_BUILD_PYTHON2_INTERFACE")
    endif()
    message(
        FATAL_ERROR
            "The Python interface is no longer compiled as part of building HELICS. On most platforms, it is enough to install with `pip install helics`. For more complex needs such as using a custom build of the HELICS library with pyhelics, see the installation docs at https://python.helics.org/installation/ and the new repository at https://github.com/gmlc-tdc/pyhelics for details.
Re-run cmake with the `-U${tmp_py_interface_option}` option to get rid of this error message."
    )
endif()

if(HELICS_BUILD_MATLAB_INTERFACE OR HELICS_BUILD_OCTAVE_INTERFACE)
    message(
        FATAL_ERROR
            "The matlab and octave interfaces are no longer compiled as part of building HELICS. Please see the repository at https://github.com/gmlc-tdc/matHELICS for details.
Re-run cmake with the `-UHELICS_BUILD_MATLAB_INTERFACE` or `-UHELICS_BUILD_OCTAVE_INTERFACE` option to get rid of this error message."
    )
endif()

cmake_dependent_option(
    HELICS_BUILD_JAVA_INTERFACE "Build Java extension" OFF "NOT HELICS_DISABLE_C_SHARED_LIB" OFF
)

# cmake projects are only available for csharp from 3.8 onward
cmake_dependent_option(
    HELICS_BUILD_CSHARP_INTERFACE "Build C# extension" OFF
    "NOT HELICS_DISABLE_C_SHARED_LIB;CMAKE_VERSION VERSION_GREATER 3.8" OFF
)

# these are purposely hidden options since they will only be used for very select purposes
option(HELICS_SWIG_GENERATE_INTERFACE_FILES_ONLY
       "Use Swig to generate the interface files but not build" OFF
)
hide_variable(HELICS_SWIG_GENERATE_INTERFACE_FILES_ONLY)

option(HELICS_OVERWRITE_INTERFACE_FILES
       "have cmake automatically overwrite the interface build files" OFF
)
hide_variable(HELICS_OVERWRITE_INTERFACE_FILES)

if(HELICS_BUILD_CSHARP_INTERFACE OR HELICS_SWIG_GENERATE_INTERFACE_FILES_ONLY)
    set(swig_required ON)
else()
    set(swig_required OFF)
endif()

# cmake-format: off

cmake_dependent_option(
    HELICS_ENABLE_SWIG
    "use swig to generate the interface files"
    OFF
    " HELICS_BUILD_JAVA_INTERFACE;NOT swig_required"
    ${swig_required}
)
# cmake-format: on

if(HELICS_ENABLE_SWIG OR swig_required)
    if(WIN32 AND NOT MSYS)
        if(NOT CMAKE_PROGRAM_PATH)
            set(CMAKE_PROGRAM_PATH
                "C:/ProgramData/chocolatey/bin"
                "C:/local/swigwin-4.0.2"
                "C:/local/swigwin-4.0.1"
                "C:/local/swigwin-4.0.0"
                "C:/local/swigwin-3.0.12"
                "C:/local/swigwin-3.0.11"
                "C:/local/swigwin-3.0.10"
            )
        else()
            set(CMAKE_PROGRAM_PATH
                "${CMAKE_PROGRAM_PATH}"
                "C:/ProgramData/chocolatey/bin"
                "C:/local/swigwin-4.0.2"
                "C:/local/swigwin-4.0.1"
                "C:/local/swigwin-4.0.0"
                "C:/local/swigwin-3.0.12"
                "C:/local/swigwin-3.0.11"
                "C:/local/swigwin-3.0.10"
            )
        endif()
    endif()
    find_package(SWIG 3 REQUIRED)
    include(${SWIG_USE_FILE})
endif()

# add base swig interface files as install option, regardless of current interfaces built
if(NOT HELICS_BINARY_ONLY_INSTALL AND NOT HELICS_DISABLE_C_SHARED_LIB)
    install(FILES helics.i DESTINATION ${CMAKE_INSTALL_DATADIR}/helics/swig COMPONENT swig)
endif()

# cmake-format: off
# add a helper variable for standalone interface swig builds
set(HELICS_SWIG_INCLUDE_DIRS "${CMAKE_CURRENT_SOURCE_DIR}" "${HELICS_SOURCE_DIR}/src/helics/shared_api_library" "${HELICS_BINARY_DIR}/src/helics/shared_api_library" "${HELICS_BINARY_DIR}/helics_generated_includes")
# cmake-format: on

# TODO: remove this after all of the interfaces work as standalone builds
include_directories(${HELICS_SWIG_INCLUDE_DIRS})

if(HELICS_BUILD_JAVA_INTERFACE)
    add_subdirectory(java)
endif()

if(HELICS_BUILD_CSHARP_INTERFACE)
    add_subdirectory(csharp)
endif()

=== comboFederates1/CMakeLists.txt ===
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Copyright (c) 2017-2025, Battelle Memorial Institute; Lawrence Livermore
# National Security, LLC; Alliance for Sustainable Energy, LLC.
# See the top-level NOTICE for additional details.
# All rights reserved.
#
# SPDX-License-Identifier: BSD-3-Clause
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

add_executable(comboFed comboFed.cpp)

target_link_libraries(comboFed PUBLIC helics_apps)
target_link_libraries(comboFed PRIVATE compile_flags_target)
set_target_properties(comboFed PROPERTIES FOLDER examples)

if(HELICS_BUILD_TESTS AND NOT MSVC)
    add_test(NAME comboFed_broker_example
             COMMAND ${PROJECT_SOURCE_DIR}/scripts/test_example.sh 10 --broker
                     $<TARGET_FILE:helics_broker> $<TARGET_FILE:comboFed>
    )
    set_property(TEST comboFed_broker_example PROPERTY LABELS Continuous)
endif()

# configure_file(${CMAKE_CURRENT_SOURCE_DIR}/run.sh ${CMAKE_CURRENT_BINARY_DIR}/run.sh COPYONLY)

add_custom_command(
    TARGET comboFed
    POST_BUILD # Adds a post-build event to api tests
    COMMAND
        ${CMAKE_COMMAND} -E copy_if_different # which executes "cmake - E copy_if_different..."
        "${CMAKE_CURRENT_SOURCE_DIR}/run.sh" # <--this is in- file
        "$<TARGET_FILE_DIR:comboFed>"
) # <--this is out-file path

=== comboFederates_cpp_shared/CMakeLists.txt ===
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Copyright (c) 2017-2025, Battelle Memorial Institute; Lawrence Livermore
# National Security, LLC; Alliance for Sustainable Energy, LLC.
# See the top-level NOTICE for additional details.
# All rights reserved.
#
# SPDX-License-Identifier: BSD-3-Clause
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

add_executable(comboFed_shared comboFed.cpp)

target_link_libraries(comboFed_shared PRIVATE compile_flags_target)
set_target_properties(comboFed_shared PROPERTIES FOLDER examples)
target_link_libraries(comboFed_shared PUBLIC helicscpp)

add_custom_command(
    TARGET comboFed_shared
    POST_BUILD # Adds a post-build event to api tests
    COMMAND
        ${CMAKE_COMMAND} -E copy_if_different # which executes "cmake -E copy_if_different..."
        "${CMAKE_CURRENT_SOURCE_DIR}/run.sh" # <--this is in- file
        "$<TARGET_FILE_DIR:comboFed_shared>/"
) # <--this is out-file path

=== csharp/CMakeLists.txt ===
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Copyright (c) 2017-2025, Battelle Memorial Institute; Lawrence Livermore
# National Security, LLC; Alliance for Sustainable Energy, LLC.
# See the top-level NOTICE for additional details.
# All rights reserved.
#
# SPDX-License-Identifier: BSD-3-Clause
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

if(SWIG_EXECUTABLE)
    # Enable generation using swig

    set_property(SOURCE helicsCsharp.i PROPERTY SWIG_MODULE_NAME helics)
    # set_source_files_properties(helicsCsharp.i PROPERTIES SWIG_FLAGS "-outfile;helics.cs")
    set_property(SOURCE file.i PROPERTY USE_LIBRARY_INCLUDE_DIRECTORIES TRUE)
    set(CMAKE_SWIG_FLAGS "-outfile;helics.cs;-I${PROJECT_BINARY_DIR}/helics_generated_includes/")
    # set(SWIG_INCLUDE_DIRECTORIES ${PROJECT_BINARY_DIR}/helics_generated_includes/)

    swig_add_library(
        CShelics
        TYPE MODULE
        LANGUAGE csharp
        SOURCES helicsCsharp.i
    )

    swig_link_libraries(CShelics helics)

    set_target_properties(
        ${SWIG_MODULE_CShelics_REAL_NAME} PROPERTIES FOLDER interfaces DEBUG_POSTFIX ""
    )

    target_include_directories(
        ${SWIG_MODULE_CShelics_REAL_NAME} PRIVATE ${HELICS_BINARY_DIR}/helics_generated_includes/
    )

else()
    message(SEND_ERROR "C# interface build requires swig")
endif() # SWIG_EXECUTABLE

# Set the output library name to _helics
set_target_properties(${SWIG_MODULE_CShelics_REAL_NAME} PROPERTIES DEBUG_POSTFIX "")

install_key_files_with_comp(csharp)

install(TARGETS ${SWIG_MODULE_CShelics_REAL_NAME} DESTINATION csharp COMPONENT csharp)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/helics.cs DESTINATION csharp COMPONENT csharp)

=== helics/CMakeLists.txt ===
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Copyright (c) 2017-2025, Battelle Memorial Institute; Lawrence Livermore
# National Security, LLC; Alliance for Sustainable Energy, LLC.
# See the top-level NOTICE for additional details.
# All rights reserved.
#
# SPDX-License-Identifier: BSD-3-Clause
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

# add a baseline library for underlying dependencies and flags for test executables

include(AddGoogletest)

# add a baseline library for underlying dependencies and flags for test executables
add_library(helics_test_base INTERFACE)
target_link_libraries(helics_test_base INTERFACE gtest gtest_main gmock)
target_link_libraries(helics_test_base INTERFACE compile_flags_target spdlog::spdlog)
target_include_directories(helics_test_base SYSTEM INTERFACE ${PROJECT_SOURCE_DIR}/ThirdParty)

add_subdirectory(core)
add_subdirectory(network)
add_subdirectory(common)
add_subdirectory(system_tests)
add_subdirectory(sequencing_tests)

if(HELICS_BUILD_APP_LIBRARY)
    add_subdirectory(apps)
    add_subdirectory(webserver)
endif()

add_subdirectory(application_api)

if(NOT HELICS_DISABLE_C_SHARED_LIB)
    add_subdirectory(shared_library)
endif()

# Configure files for encryption tests
if(HELICS_ENABLE_ENCRYPTION)
    configure_file(
        "test_files/encryption_config/openssl.json.in" "test_files/encryption_config/openssl.json"
    )
    configure_file(
        "test_files/encryption_config/multiBroker_encrypted_bridge.json.in"
        "test_files/encryption_config/multiBroker_encrypted_bridge.json"
    )
endif()

if(HELICS_INSTALL_PACKAGE_TESTS)
    set(HELICS_PACKAGE_SEARCH_LOC)
else()
    set(HELICS_PACKAGE_SEARCH_LOC "-DHELICS_DIR=${PROJECT_BINARY_DIR}")
endif()

if(NOT MSVC)
    set(package_test_command --test-command "${CMAKE_CTEST_COMMAND}")
else() # don't try to run the tests on MSVC since that would require copying the dll's and doing
       # some other setup that isn't that important to run on all OS
    set(package_test_command)
endif()

if(CMAKE_BUILD_TYPE)
    set(HELICS_PACKAGE_TEST_BUILD_TYPE ${CMAKE_BUILD_TYPE})
else()
    set(HELICS_PACKAGE_TEST_BUILD_TYPE Release)
endif()

file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/find_package_tests")

if(MSVC)
    # Tests for other CMake projects including and using HELICS using find_package
    add_test(
        NAME find-package-testsA
        COMMAND
            ${CMAKE_COMMAND} -G "${CMAKE_GENERATOR}" -A "${CMAKE_GENERATOR_PLATFORM}"
            ${HELICS_PACKAGE_SEARCH_LOC}
            "-DHELICS_BUILD_CXX_SHARED_LIB=${HELICS_BUILD_CXX_SHARED_LIB}"
            "-DHELICS_DISABLE_C_SHARED_LIB=${HELICS_DISABLE_C_SHARED_LIB}"
            "-DHELICS_VERSION=${HELICS_VERSION}" "-DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}"
            "-DCMAKE_CXX_STANDARD=${CMAKE_CXX_STANDARD}"
            "-DCMAKE_RUNTIME_OUTPUT_DIRECTORY=${CMAKE_RUNTIME_OUTPUT_DIRECTORY}"
            "${CMAKE_CURRENT_SOURCE_DIR}/find_package_tests"
        WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/find_package_tests"
    )
else()
    add_test(
        NAME find-package-testsA
        COMMAND
            ${CMAKE_COMMAND} -G "${CMAKE_GENERATOR}" ${HELICS_PACKAGE_SEARCH_LOC}
            "-DHELICS_BUILD_CXX_SHARED_LIB=${HELICS_BUILD_CXX_SHARED_LIB}"
            "-DHELICS_DISABLE_C_SHARED_LIB=${HELICS_DISABLE_C_SHARED_LIB}"
            "-DHELICS_BUILD_APP_LIBRARY=${HELICS_BUILD_APP_LIBRARY}"
            "-DHELICS_VERSION=${HELICS_VERSION}" "-DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}"
            "-DCMAKE_CXX_STANDARD=${CMAKE_CXX_STANDARD}"
            "-DCMAKE_RUNTIME_OUTPUT_DIRECTORY=${CMAKE_RUNTIME_OUTPUT_DIRECTORY}"
            "${CMAKE_CURRENT_SOURCE_DIR}/find_package_tests"
        WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/find_package_tests"
    )
endif()

add_test(NAME find-package-testsB
         COMMAND ${CMAKE_COMMAND} --build "${CMAKE_CURRENT_BINARY_DIR}/find_package_tests" --config
                 ${HELICS_PACKAGE_TEST_BUILD_TYPE}
)

add_test(NAME find-package-testsC COMMAND ${CMAKE_CTEST_COMMAND} -C
                                          ${HELICS_PACKAGE_TEST_BUILD_TYPE}
         WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/find_package_tests"
)
set_property(TEST find-package-testsA PROPERTY LABELS Packaging PackagingFast)
set_property(TEST find-package-testsB PROPERTY LABELS Packaging PackagingFast)
set_property(TEST find-package-testsB PROPERTY DEPENDS find-package-testsA)
set_property(TEST find-package-testsC PROPERTY LABELS Packaging PackagingFast)
set_property(TEST find-package-testsC PROPERTY DEPENDS find-package-testsB)

cmake_dependent_advanced_option(
    HELICS_ENABLE_SUBPROJECT_TESTS
    "Enable tests of using HELICS as a subproject, potentially a slow tests" OFF
    "HELICS_BUILD_TESTS" OFF
)

# Tests for adding HELICS as a subproject using add_subdirectory
if(HELICS_ENABLE_SUBPROJECT_TESTS)
    add_test(
        add-subdirectory-tests
        ${CMAKE_CTEST_COMMAND}
        -C
        ${HELICS_PACKAGE_TEST_BUILD_TYPE}
        --build-and-test
        "${CMAKE_CURRENT_SOURCE_DIR}/add_subdirectory_tests"
        "${CMAKE_CURRENT_BINARY_DIR}/add_subdirectory_tests"
        --build-generator
        "${CMAKE_GENERATOR}"
        --build-generator-platform
        "${CMAKE_GENERATOR_PLATFORM}"
        --build-options
        "-DHELICS_BUILD_CXX_SHARED_LIB=${HELICS_BUILD_CXX_SHARED_LIB}"
        "-DHELICS_DISABLE_C_SHARED_LIB=${HELICS_DISABLE_C_SHARED_LIB}"
        "-DHELICS_BUILD_APP_LIBRARY=${HELICS_BUILD_APP_LIBRARY}"
        "-DHELICS_VERSION=${HELICS_VERSION}"
        "-DZeroMQ_INSTALL_PATH=${ZeroMQ_INSTALL_PATH}"
        "-DBOOST_INSTALL_PATH=${BOOST_INSTALL_PATH}"
        "-DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}"
        "-DCMAKE_CXX_STANDARD=${CMAKE_CXX_STANDARD}"
    )
    set_property(TEST add-subdirectory-tests PROPERTY LABELS Packaging)
endif()

if(NOT MSVC AND HELICS_INSTALL_PACKAGE_TESTS)
    # Tests for other CMake projects using the package_config files
    add_test(
        package-config-tests
        ${CMAKE_CTEST_COMMAND}
        -C
        ${HELICS_PACKAGE_TEST_BUILD_TYPE}
        --build-and-test
        "${CMAKE_CURRENT_SOURCE_DIR}/package_config_tests"
        "${CMAKE_CURRENT_BINARY_DIR}/package_config_tests"
        --build-generator
        "${CMAKE_GENERATOR}"
        --build-generator-platform
        "${CMAKE_GENERATOR_PLATFORM}"
        --build-options
        "-DHELICS_BUILD_CXX_SHARED_LIB=${HELICS_BUILD_CXX_SHARED_LIB}"
        "-DHELICS_DISABLE_C_SHARED_LIB=${HELICS_DISABLE_C_SHARED_LIB}"
        "-DHELICS_BUILD_APP_LIBRARY=${HELICS_BUILD_APP_LIBRARY}"
        "-DHELICS_VERSION=${HELICS_VERSION}"
        "-DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}"
        "-DCMAKE_CXX_STANDARD=${CMAKE_CXX_STANDARD}"
        ${package_test_command}
    )
    set_property(TEST package-config-tests PROPERTY LABELS Packaging)
endif()

=== helics/application_api/CMakeLists.txt ===
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Copyright (c) 2017-2025, Battelle Memorial Institute; Lawrence Livermore
# National Security, LLC; Alliance for Sustainable Energy, LLC.
# See the top-level NOTICE for additional details.
# All rights reserved.
#
# SPDX-License-Identifier: BSD-3-Clause
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

set(application_api_headers
    CombinationFederate.hpp
    CallbackFederate.hpp
    Publications.hpp
    Subscriptions.hpp
    Endpoints.hpp
    Filters.hpp
    Translator.hpp
    Federate.hpp
    helicsTypes.hpp
    data_view.hpp
    MessageFederate.hpp
    MessageOperators.hpp
    ValueConverter.hpp
    ValueFederate.hpp
    HelicsPrimaryTypes.hpp
    queryFunctions.hpp
    FederateInfo.hpp
    Inputs.hpp
    BrokerApp.hpp
    CoreApp.hpp
)

set(conv_headers ../application_api.hpp ../ValueFederates.hpp ../MessageFederates.hpp)

set(private_application_api_headers
    MessageFederateManager.hpp
    ValueFederateManager.hpp
    AsyncFedCallInfo.hpp
    FilterOperations.hpp
    ConnectorFederateManager.hpp
    TranslatorOperations.hpp
    PotentialInterfacesManager.hpp
)

set(application_api_sources
    CombinationFederate.cpp
    Federate.cpp
    MessageFederate.cpp
    MessageFederateManager.cpp
    MessageOperators.cpp
    ValueFederate.cpp
    ValueConverter.cpp
    ValueFederateManager.cpp
    helicsPrimaryTypes.cpp
    Publications.cpp
    Filters.cpp
    FilterOperations.cpp
    ConnectorFederateManager.cpp
    PotentialInterfacesManager.cpp
    Translator.cpp
    TranslatorOperations.cpp
    Endpoints.cpp
    helicsTypes.cpp
    queryFunctions.cpp
    FederateInfo.cpp
    CallbackFederate.cpp
    Inputs.cpp
    BrokerApp.cpp
    CoreApp.cpp
)

add_library(
    helics_application_api STATIC ${application_api_sources} ${conv_headers}
                                  ${application_api_headers} ${private_application_api_headers}
)

target_link_libraries(helics_application_api PUBLIC HELICS::network)
target_link_libraries(helics_application_api PRIVATE fmt::fmt)
target_compile_definitions(helics_application_api PUBLIC HELICS_CXX_STATIC_DEFINE)
if(MSYS AND USE_LIBCXX)
    target_compile_definitions(helics_application_api PUBLIC "-DSTX_NO_STD_OPTIONAL=1")
endif()

add_library(HELICS::application_api ALIAS helics_application_api)

=== helics/apps/CMakeLists.txt ===
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Copyright (c) 2017-2025, Battelle Memorial Institute; Lawrence Livermore
# National Security, LLC; Alliance for Sustainable Energy, LLC.
# See the top-level NOTICE for additional details.
# All rights reserved.
#
# SPDX-License-Identifier: BSD-3-Clause
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

set(helics_apps_test_sources
    helics_apps_tests.cpp
    multi_player_tests.cpp
    multi_tests.cpp
    PlayerTests.cpp
    RecorderTests.cpp
    exeTestHelper.cpp
    combo_tests.cpp
    EchoTests.cpp
    TracerTests.cpp
    SourceTests.cpp
    CloneTests.cpp
    BrokerServerTests.cpp
    CoreAppTests.cpp
    BrokerAppTests.cpp
    MultiBrokerTests.cpp
    ProbeTests.cpp
    ConnectorTests.cpp
    ConnectorTests2.cpp
    ConnectorFileTests.cpp
    Connector2StageTests.cpp
    ConnectorTagTests.cpp
    ConnectorTestsPotentialInterfaces.cpp
    exeTestHelper.h
)

add_executable(helics_apps-tests ${helics_apps_test_sources})

set_target_properties(helics_apps-tests PROPERTIES FOLDER tests)

target_link_libraries(helics_apps-tests helics_apps helics_test_base)

target_include_directories(helics_apps-tests PRIVATE ${PROJECT_SOURCE_DIR}/src)

target_compile_definitions(
    helics_apps-tests PRIVATE "-DTEST_DIR=\"${CMAKE_CURRENT_SOURCE_DIR}/test_files/\""
)
target_compile_definitions(
    helics_apps-tests PRIVATE "-DGLOBAL_TEST_DIR=\"${CMAKE_CURRENT_SOURCE_DIR}/../test_files/\""
)
target_compile_definitions(
    helics_apps-tests PRIVATE "-DHELICS_BUILD_LOC=\"${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/\""
)
target_compile_definitions(
    helics_apps-tests
    PRIVATE "-DHELICS_INSTALL_LOC=\"${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}\""
)

if(HELICS_DISABLE_SYSTEM_CALL_TESTS)
    target_compile_definitions(helics_apps-tests PRIVATE -DDISABLE_SYSTEM_CALL_TESTS=1)
endif()

add_test(NAME helics_apps-tests COMMAND helics_apps-tests)
set_property(TEST helics_apps-tests PROPERTY LABELS HelicsApps Coverage Daily)

# Tests for Continuous Integration builds
add_test(NAME helics_apps-ci-tests COMMAND helics_apps-tests --gtest_filter=-*_exe*:*ci_skip*)
set_property(TEST helics_apps-ci-tests PROPERTY LABELS HelicsAppsCI Continuous)

if(HELICS_BUILD_CXX_SHARED_LIB)
    set(helics_shared_apps_test_sources
        helics_apps_tests.cpp
        PlayerTests.cpp
        RecorderTests.cpp
        EchoTests.cpp
        TracerTests.cpp
        SourceTests.cpp
        CloneTests.cpp
    )

    add_executable(shared_cxx_app-tests ${helics_shared_apps_test_sources})

    target_link_libraries(shared_cxx_app-tests helics_test_base helics_base HELICS::helicscpp-apps)

    set_target_properties(shared_cxx_app-tests PROPERTIES FOLDER tests)

    add_test(NAME shared_cxx_app-tests COMMAND shared_cxx_app-tests)
    set_property(TEST shared_cxx_app-tests PROPERTY LABELS ApplicationApi Coverage Daily Continuous)

    target_compile_definitions(
        shared_cxx_app-tests PRIVATE "-DTEST_DIR=\"${CMAKE_CURRENT_SOURCE_DIR}/test_files/\""
    )

    target_compile_definitions(shared_cxx_app-tests PRIVATE DISABLE_SYSTEM_CALL_TESTS)

endif()

=== helics/common/CMakeLists.txt ===
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Copyright (c) 2017-2025, Battelle Memorial Institute; Lawrence Livermore
# National Security, LLC; Alliance for Sustainable Energy, LLC.
# See the top-level NOTICE for additional details.
# All rights reserved.
#
# SPDX-License-Identifier: BSD-3-Clause
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

# -----------------------------------------------------------------------------
# Common library tests using Boost
# -----------------------------------------------------------------------------

set(common_test_headers)

set(common_test_sources TimeTests.cpp JsonGenerationTests.cpp SmallBufferTests.cpp)

add_executable(common-tests ${common_test_sources} ${common_test_headers})
target_link_libraries(common-tests PRIVATE HELICS::core helics_test_base fmt::fmt)
set_target_properties(common-tests PROPERTIES FOLDER tests)

add_test(NAME common-tests COMMAND common-tests)
set_property(TEST common-tests PROPERTY LABELS Common Daily Coverage Continuous)

=== helics/core/CMakeLists.txt ===
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Copyright (c) 2017-2025, Battelle Memorial Institute; Lawrence Livermore
# National Security, LLC; Alliance for Sustainable Energy, LLC.
# See the top-level NOTICE for additional details.
# All rights reserved.
#
# SPDX-License-Identifier: BSD-3-Clause
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

set(SRC_FILES
    CoreFactory.cpp
    BrokerFactory.cpp
    BrokerBase.cpp
    CommonCore.cpp
    FederateState.cpp
    PublicationInfo.cpp
    InputInfo.cpp
    InterfaceInfo.cpp
    EndpointInfo.cpp
    ActionMessage.cpp
    CoreBroker.cpp
    TimeCoordinator.cpp
    BaseTimeCoordinator.cpp
    ForwardingTimeCoordinator.cpp
    GlobalTimeCoordinator.cpp
    AsyncTimeCoordinator.cpp
    TimeDependencies.cpp
    HandleManager.cpp
    FilterInfo.cpp
    FilterCoordinator.cpp
    FilterFederate.cpp
    UnknownHandleManager.cpp
    LocalFederateId.cpp
    TimeoutMonitor.cpp
    coreTypeOperations.cpp
    helicsCLI11JsonConfig.cpp
    TranslatorFederate.cpp
    TimeCoordinatorProcessing.cpp
    BasicHandleInfo.cpp
    queryHelpers.cpp
    ProfilerBuffer.cpp
    EmptyCore.cpp
    helicsVersion.cpp
    TranslatorInfo.cpp
    LogManager.cpp
)

set(PUBLIC_INCLUDE_FILES
    Core.hpp
    Broker.hpp
    CoreFactory.hpp
    BrokerFactory.hpp
    core-exceptions.hpp
    CoreTypes.hpp
    core-data.hpp
    helicsTime.hpp
    CoreFederateInfo.hpp
    helicsVersion.hpp
    LocalFederateId.hpp
    helics_definitions.hpp
    helicsCLI11.hpp
    SmallBuffer.hpp
)

set(INCLUDE_FILES
    coreTypeOperations.hpp
    BrokerBase.hpp
    TimeDependencies.hpp
    TimeCoordinator.hpp
    BaseTimeCoordinator.hpp
    ForwardingTimeCoordinator.hpp
    GlobalTimeCoordinator.hpp
    AsyncTimeCoordinator.hpp
    loggingHelper.hpp
    GlobalFederateId.hpp
    basic_CoreTypes.hpp
    TimeoutMonitor.h
    CoreBroker.hpp
    InterfaceInfo.hpp
    ActionMessageDefintions.hpp
    ActionMessage.hpp
    CommonCore.hpp
    EmptyCore.hpp
    FederateState.hpp
    PublicationInfo.hpp
    InputInfo.hpp
    EndpointInfo.hpp
    TranslatorInfo.hpp
    flagOperations.hpp
    BasicHandleInfo.hpp
    FederateIdExtra.hpp
    FilterInfo.hpp
    FilterCoordinator.hpp
    FilterFederate.hpp
    TranslatorFederate.hpp
    HandleManager.hpp
    UnknownHandleManager.hpp
    queryHelpers.hpp
    fileConnections.hpp
    helicsCLI11JsonConfig.hpp
    TimeCoordinatorProcessing.hpp
    ProfilerBuffer.hpp
    LogManager.hpp
    ../helics_enums.h
)

if(NOT HELICS_DISABLE_ASIO)
    list(APPEND SRC_FILES MessageTimer.cpp)
    list(APPEND INCLUDE_FILES MessageTimer.hpp)
endif()

add_library(helics_core STATIC ${SRC_FILES} ${INCLUDE_FILES} ${PUBLIC_INCLUDE_FILES})

target_link_libraries(
    helics_core PUBLIC HELICS::common gmlc::networking PRIVATE spdlog::spdlog fmt::fmt
                                                               compile_flags_target
)

add_library(HELICS::core ALIAS helics_core)

target_compile_options(
    helics_core
    PRIVATE $<$<COMPILE_LANGUAGE:CXX>:$<$<NOT:$<CXX_COMPILER_ID:MSVC>>:-Wno-strict-aliasing>>
)

# adding a definition flag for some interaction with the shared library
target_compile_definitions(helics_core PUBLIC HELICS_STATIC_CORE_LIBRARY)

=== helics/network/CMakeLists.txt ===
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Copyright (c) 2017-2025, Battelle Memorial Institute; Lawrence Livermore
# National Security, LLC; Alliance for Sustainable Energy, LLC.
# See the top-level NOTICE for additional details.
# All rights reserved.
#
# SPDX-License-Identifier: BSD-3-Clause
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

set(NETWORK_SRC_FILES
    NetworkCommsInterface.cpp
    NetworkBrokerData.cpp
    CommsInterface.cpp
    CommsBroker.cpp
    loadCores.cpp
    networkDefaults.cpp
)

set(TESTCORE_SOURCE_FILES test/TestBroker.cpp test/TestCore.cpp test/TestComms.cpp)

set(INPROCCORE_SOURCE_FILES inproc/InprocBroker.cpp inproc/InprocCore.cpp inproc/InprocComms.cpp)

set(IPC_SOURCE_FILES ipc/IpcCore.cpp ipc/IpcBroker.cpp ipc/IpcComms.cpp ipc/IpcQueueHelper.cpp
                     # ipc/IpcBlockingPriorityQueue.cpp ipc/IpcBlockingPriorityQueueImpl.cpp
)

set(MPI_SOURCE_FILES mpi/MpiCore.cpp mpi/MpiBroker.cpp mpi/MpiComms.cpp mpi/MpiService.cpp)

set(ZMQ_SOURCE_FILES
    zmq/ZmqCore.cpp
    zmq/ZmqBroker.cpp
    zmq/ZmqComms.cpp
    zmq/ZmqCommsSS.cpp
    zmq/ZmqRequestSets.cpp
    zmq/ZmqCommsCommon.cpp
    zmq/ZmqContextManager.cpp
    # zmq/zmqSocketDescriptor.cpp
    zmq/ZmqHelper.cpp
)

set(UDP_SOURCE_FILES udp/UdpCore.cpp udp/UdpBroker.cpp udp/UdpComms.cpp)

set(TCP_SOURCE_FILES tcp/TcpCore.cpp tcp/TcpBroker.cpp tcp/TcpComms.cpp tcp/TcpCommsSS.cpp
                     tcp/TcpCommsCommon.cpp
)

set(NETWORK_INCLUDE_FILES
    NetworkCommsInterface.hpp
    NetworkBrokerData.hpp
    NetworkBroker.hpp
    NetworkCore.hpp
    NetworkBroker_impl.hpp
    NetworkCore_impl.hpp
    networkDefaults.hpp
    CommsBroker.hpp
    CommsBroker_impl.hpp
    CommsInterface.hpp
    loadCores.hpp
)

set(TESTCORE_HEADER_FILES test/TestCore.h test/TestBroker.h test/TestComms.h)

set(INPROCCORE_HEADER_FILES inproc/InprocCore.h inproc/InprocBroker.h inproc/InprocComms.h)

set(IPC_HEADER_FILES ipc/IpcCore.h ipc/IpcBroker.h ipc/IpcComms.h ipc/IpcQueueHelper.h
                     # ipc/IpcBlockingPriorityQueue.hpp ipc/IpcBlockingPriorityQueueImpl.hpp
)

set(ZMQ_HEADER_FILES
    zmq/ZmqCore.h
    zmq/ZmqBroker.h
    zmq/ZmqComms.h
    zmq/ZmqCommsSS.h
    zmq/ZmqRequestSets.h
    zmq/ZmqCommsCommon.h
    zmq/ZmqContextManager.h
    # zmq/zmqSocketDescriptor.h
    zmq/ZmqHelper.h
    ${HELICS_SOURCE_DIR}/ThirdParty/cppzmq/zmq.hpp
    ${HELICS_SOURCE_DIR}/ThirdParty/cppzmq/zmq_addon.hpp
)

set(MPI_HEADER_FILES mpi/MpiCore.h mpi/MpiBroker.h mpi/MpiComms.h mpi/MpiService.h)

set(UDP_HEADER_FILES udp/UdpCore.h udp/UdpBroker.h udp/UdpComms.h)

set(TCP_HEADER_FILES tcp/TcpCore.h tcp/TcpBroker.h tcp/TcpComms.h tcp/TcpCommsSS.h
                     tcp/TcpCommsCommon.h
)

if(HELICS_ENABLE_TEST_CORE)
    list(APPEND NETWORK_SRC_FILES ${TESTCORE_SOURCE_FILES})
    list(APPEND NETWORK_INCLUDE_FILES ${TESTCORE_HEADER_FILES})
endif()

if(HELICS_ENABLE_INPROC_CORE)
    list(APPEND NETWORK_SRC_FILES ${INPROCCORE_SOURCE_FILES})
    list(APPEND NETWORK_INCLUDE_FILES ${INPROCCORE_HEADER_FILES})
endif()

if(HELICS_ENABLE_UDP_CORE)
    list(APPEND NETWORK_SRC_FILES ${UDP_SOURCE_FILES})
    list(APPEND NETWORK_INCLUDE_FILES ${UDP_HEADER_FILES})
endif()

if(HELICS_ENABLE_IPC_CORE)
    list(APPEND NETWORK_SRC_FILES ${IPC_SOURCE_FILES})
    list(APPEND NETWORK_INCLUDE_FILES ${IPC_HEADER_FILES})
endif()

if(HELICS_ENABLE_TCP_CORE)
    list(APPEND NETWORK_SRC_FILES ${TCP_SOURCE_FILES})
    list(APPEND NETWORK_INCLUDE_FILES ${TCP_HEADER_FILES})
endif()

if(HELICS_ENABLE_ZMQ_CORE)
    list(APPEND NETWORK_SRC_FILES ${ZMQ_SOURCE_FILES})
    list(APPEND NETWORK_INCLUDE_FILES ${ZMQ_HEADER_FILES})
endif()

if(HELICS_ENABLE_MPI_CORE)
    list(APPEND NETWORK_SRC_FILES ${MPI_SOURCE_FILES})
    list(APPEND NETWORK_INCLUDE_FILES ${MPI_HEADER_FILES})
endif()

add_library(helics_network STATIC ${NETWORK_SRC_FILES} ${NETWORK_INCLUDE_FILES})

target_link_libraries(
    helics_network PUBLIC HELICS::core PRIVATE gmlc::networking fmt::fmt compile_flags_target
)

if(HELICS_ENABLE_ZMQ_CORE)
    target_link_libraries(helics_network PRIVATE helics::zmq)
endif()

if(TARGET Boost::boost AND NOT HELICS_DISABLE_BOOST)
    target_compile_definitions(helics_network PRIVATE BOOST_DATE_TIME_NO_LIB)
    target_link_libraries(helics_network PRIVATE Boost::boost)
endif()

if(HELICS_ENABLE_MPI_CORE)
    source_group("mpi" FILES ${MPI_SOURCE_FILES} ${MPI_HEADER_FILES})
endif()

if(HELICS_ENABLE_ZMQ_CORE)
    source_group("zmq" FILES ${ZMQ_SOURCE_FILES} ${ZMQ_HEADER_FILES})
endif()

if(HELICS_ENABLE_UDP_CORE)
    source_group("udp" FILES ${UDP_SOURCE_FILES} ${UDP_HEADER_FILES})
endif()

if(HELICS_ENABLE_IPC_CORE)
    source_group("ipc" FILES ${IPC_SOURCE_FILES} ${IPC_HEADER_FILES})
endif()

if(HELICS_ENABLE_TEST_CORE)
    source_group("test" FILES ${TESTCORE_SOURCE_FILES} ${TESTCORE_HEADER_FILES})
endif()

if(HELICS_ENABLE_TCP_CORE)
    source_group("tcp" FILES ${TCP_SOURCE_FILES} ${TCP_HEADER_FILES})
endif()

if(HELICS_ENABLE_INPROC_CORE)
    source_group("inproc" FILES ${INPROCCORE_SOURCE_FILES} ${INPROCCORE_HEADER_FILES})
endif()

if(HELICS_ENABLE_MPI_CORE)
    target_include_directories(
        helics_network PRIVATE "${MPI_C_INCLUDE_DIR}" "${MPI_C_HEADER_DIR}"
                               "${MPI_C_ADDITIONAL_INCLUDE_DIRS}"
    )
endif()

add_library(HELICS::network ALIAS helics_network)

target_compile_options(
    helics_network
    PRIVATE $<$<COMPILE_LANGUAGE:CXX>:$<$<NOT:$<CXX_COMPILER_ID:MSVC>>:-Wno-strict-aliasing>>
)

=== helics/package_config_tests/CMakeLists.txt ===
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Copyright (c) 2017-2025, Battelle Memorial Institute; Lawrence Livermore
# National Security, LLC; Alliance for Sustainable Energy, LLC.
# See the top-level NOTICE for additional details.
# All rights reserved.
#
# SPDX-License-Identifier: BSD-3-Clause
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

cmake_minimum_required(VERSION 3.10..3.23)

project(HELICS-package_config-tests)

include(CTest)

find_package(PkgConfig)

# Test the CXX shared library target
if(HELICS_BUILD_CXX_SHARED_LIB)
    pkg_check_modules(HELICSCPP REQUIRED IMPORTED_TARGET helicscpp)
    add_executable(shared-library-test-exe ../pkg_test_code/main.cpp)
    target_link_libraries(shared-library-test-exe PkgConfig::HELICSCPP)

    add_test(NAME shared-library-test COMMAND shared-library-test-exe)
    set_property(TEST shared-library-test PROPERTY PASS_REGULAR_EXPRESSION "${HELICS_VERSION}")

    # Test the helics_app static library target
    if(HELICS_BUILD_APP_LIBRARY)
        pkg_check_modules(HELICS_APPS REQUIRED IMPORTED_TARGET helicscpp-apps)
        add_executable(apps-library-test-exe ../pkg_test_code/main-apps.cpp)
        target_link_libraries(apps-library-test-exe PkgConfig::HELICS_APPS)

        add_test(NAME apps-library-test COMMAND apps-library-test-exe)
        set_property(TEST apps-library-test PROPERTY PASS_REGULAR_EXPRESSION "${HELICS_VERSION}")
    endif()

endif()

# Test the C and C++98 targets
if(NOT HELICS_DISABLE_C_SHARED_LIB)

    pkg_check_modules(HELICS REQUIRED IMPORTED_TARGET helics)
    add_executable(c-shared-library-test-exe ../pkg_test_code/main.c)
    target_link_libraries(c-shared-library-test-exe PkgConfig::HELICS)

    add_test(NAME c-shared-library-test COMMAND c-shared-library-test-exe)
    set_property(TEST c-shared-library-test PROPERTY PASS_REGULAR_EXPRESSION "${HELICS_VERSION}")

    add_executable(cpp98-shared-library-test-exe ../pkg_test_code/main98.cpp)
    target_link_libraries(cpp98-shared-library-test-exe PkgConfig::HELICS)
    set_property(TARGET cpp98-shared-library-test-exe PROPERTY CXX_STANDARD 98)

    add_test(NAME cpp98-shared-library-test COMMAND cpp98-shared-library-test-exe)
    set_property(
        TEST cpp98-shared-library-test PROPERTY PASS_REGULAR_EXPRESSION "${HELICS_VERSION}"
    )
endif()

=== helics/shared_library/CMakeLists.txt ===
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Copyright (c) 2017-2025, Battelle Memorial Institute; Lawrence Livermore
# National Security, LLC; Alliance for Sustainable Energy, LLC.
# See the top-level NOTICE for additional details.
# All rights reserved.
#
# SPDX-License-Identifier: BSD-3-Clause
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

set(c_shared_library_test_sources
    ctestFixtures.cpp
    shared-library-tests.cpp
    test-value-federate1.cpp
    test-value-federate2.cpp
    FilterTests.cpp
    TranslatorTests.cpp
    test-message-federate.cpp
    SystemTests.cpp
    TimingTests.cpp
    evilInputTests.cpp
    iterationTests.cpp
    QueryTests.cpp
    DataAPITests.cpp
    badInputTests.cpp
    comboConfigTests.cpp
    loggingTests.cpp
    PropertyIndexTests.cpp
    commandInterfaceTests.cpp
    miscApiTests.cpp
    CallbackFederateTests.cpp
)

if(TARGET HELICS::apps)
    list(APPEND c_shared_library_test_sources appTests.cpp)
endif()

set(cpp_shared_library_test_sources
    cpptestFixtures.cpp
    cppshared-library-tests.cpp
    # test-value-federate1_cpp.cpp
    test-value-federate2_cpp.cpp
    # FilterTests_cpp.cpp
    test-message-federate_cpp.cpp
    test-combo-federate_cpp.cpp
    timingTests_cpp.cpp
    QueryTests_cpp.cpp
    MultiInputTests.cpp
)

add_executable(
    shared-library-tests ${c_shared_library_test_sources} ctestFixtures.hpp ../coreTypeLists.hpp
)

add_executable(
    shared-library-tests-cpp ${cpp_shared_library_test_sources} cpptestFixtures.hpp
                             ../coreTypeLists.hpp
)

target_link_libraries(shared-library-tests helics_test_base helics build_flags_target)
target_link_libraries(shared-library-tests-cpp helics_test_base helicsCpp98 build_flags_target)

set_target_properties(shared-library-tests shared-library-tests-cpp PROPERTIES FOLDER tests)

target_compile_definitions(
    shared-library-tests PRIVATE "-DHELICS_BROKER_LOCATION=\"${HELICS_BROKER_LOC}\""
)
target_compile_definitions(
    shared-library-tests PRIVATE "-DHELICS_INSTALL_LOCATION=\"${CMAKE_INSTALL_PREFIX}\""
)

target_compile_definitions(
    shared-library-tests PRIVATE "-DTEST_DIR=\"${CMAKE_CURRENT_SOURCE_DIR}/../test_files/\""
)

if(TARGET HELICS::apps)
    target_compile_definitions(
        shared-library-tests
        PRIVATE "-DAPP_TEST_DIR=\"${CMAKE_CURRENT_SOURCE_DIR}/../apps/test_files/\""
    )
endif()

add_test(NAME shared-library-tests COMMAND shared-library-tests)

target_compile_definitions(
    shared-library-tests-cpp PRIVATE "-DHELICS_BROKER_LOCATION=\"${HELICS_BROKER_LOC}\""
)
target_compile_definitions(
    shared-library-tests-cpp PRIVATE "-DHELICS_INSTALL_LOCATION=\"${CMAKE_INSTALL_PREFIX}\""
)

target_compile_definitions(
    shared-library-tests-cpp PRIVATE "-DTEST_DIR=\"${CMAKE_CURRENT_SOURCE_DIR}/../test_files/\""
)

add_test(NAME shared-library-tests-cpp COMMAND shared-library-tests-cpp)

set_property(TEST shared-library-tests PROPERTY LABELS SharedLibrary Coverage Daily)

set_property(TEST shared-library-tests-cpp PROPERTY LABELS SharedLibraryCpp Coverage Daily)

# Tests used for Continuous Integration builds
add_test(NAME shared-library-ci-tests COMMAND shared-library-tests
                                              --gtest_filter=-*ci_skip*:*nosan*
)
add_test(NAME shared-library-ci-tests-cpp COMMAND shared-library-tests-cpp
                                                  --gtest_filter=-*ci_skip*:*nosan*
)

set_property(TEST shared-library-ci-tests PROPERTY LABELS SharedLibraryCI Continuous)
set_property(TEST shared-library-ci-tests-cpp PROPERTY LABELS SharedLibraryCppCI Continuous)

=== PKGBUILD ===
# Maintainer: Philip Top <top1@llnl.gov>

_realname=helics
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=3.6.1
pkgrel=3
pkgdesc="Hierarchical Engine for Large-scale Infrastructure Co-Simulation (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://github.com/GMLC-TDC/HELICS"
license=('spdx:BSD-3-Clause')
depends=("${MINGW_PACKAGE_PREFIX}-zeromq"
         "${MINGW_PACKAGE_PREFIX}-fmt")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-boost")
options=('!strip')
source=("https://github.com/GMLC-TDC/HELICS/releases/download/v${pkgver}/HELICS-v${pkgver}-source.tar.gz"
        "001-aarch64-processor-name.patch")
sha256sums=('d607c1b47dd5ae32f3076c4aa4aa584d37b6056a9bd049234494698ed95cd70f'
            '5853683dc368453155bf690fb9082b98e88da5d854de8f2da8f32830996f0013')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd "${srcdir}"

  apply_patch_with_msg \
    001-aarch64-processor-name.patch
}

build() {
  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    -G"Ninja" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -DCMAKE_CXX_STANDARD=20 \
    -DBUILD_SHARED_LIBS=ON \
    -DHELICS_ENABLE_IPC_CORE=OFF \
    -DHELICS_DISABLE_GIT_OPERATIONS=ON \
    -DHELICS_DISABLE_VCPKG=ON \
    -DHELICS_DISABLE_ASIO=$([[ ${MINGW_PACKAGE_PREFIX} != *-clang-* ]] && echo "OFF" || echo "ON") \
    -DHELICS_USE_EXTERNAL_FMT=ON \
    ${extra_config} \
    ..

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .
  rm -f "${pkgdir}"${MINGW_PREFIX}/bin/libzmq.dll.a
}
